var Table = function() {
    this.rows = new Array();
    this.columns = new Array();
    this.cells = new Array();
}

/**
 * Public methods
 */
Table.prototype.drawCells = function() {
    $('.tablesWindow').empty();
    var firstRow = $('<div/>', {
        class: 'row firstRow'
    });
    firstRow.appendTo($('.tablesWindow'));
    $('<div/>', {
        class: 'cell firstCell',
        html: "&nbsp"
    }).appendTo(firstRow);
    for (var columnId = 0; columnId < this.columns.length; columnId++) {
        var charColumn = this.columns[columnId].char;
        $('<div/>', {
            class: 'cell headerCell',
            html: charColumn
        }).appendTo(firstRow);
    }


    for (var rowId = 0; rowId < this.rows.length; rowId++) {
        var newRow = $('<div/>', {
            class: 'row'
        });
        var charFirstCell = this.rows[rowId].char;
        newRow.appendTo($('.tablesWindow'));
        $('<div/>', {
            class: 'cell firstCell',
            html: charFirstCell
        }).appendTo(newRow);
        for (var columnId = 0; columnId < this.columns.length; columnId++) {
            var cellText = this.getCell(rowId, columnId).text;
            // main editable cell
            $('<div/>',{
                id: rowId + "," + columnId,
                class: 'cell',
                html: cellText
            }).appendTo(newRow);
        }
    }
    addListeners();
}

Table.prototype.getCell = function(rowId, columnId) {
    for (var cellId = 0; cellId < this.cells.length; cellId++) {
        if (this.cells[cellId].row    == rowId &&
            this.cells[cellId].column == columnId) {
            return this.cells[cellId];
        }
    }
    return -1;
}

Table.prototype.fillCells = function() {
    for (var rowId = 0; rowId < this.rows.length; rowId++) {
        for (var columnId = 0; columnId < this.columns.length; columnId++) {
            var cell = new Cell(this.rows[rowId].id, this.columns[columnId].id);
            this.cells.push(cell);
        }
    }
}

Table.prototype.fillRows = function(rowsCount) {
    this.rows = new Array(rowsCount);
    for (var i = 0; i < rowsCount; i++) {
        this.rows[i] = {
            id: i,
            char: i + 1
        }
    }
}

Table.prototype.fillColumns = function(columnsCount) {
    this.columns = new Array(columnsCount);
    var charNumber = 65;

    for (var i = 0; i < columnsCount; i++) {
        var charTmp = String.fromCharCode(charNumber + i);
        this.columns[i] = {
            id: i,
            char: charTmp
        }
    }
}
